#!/usr/bin/perl
#########################################################################
# MultiCount Version 1.01						#
# Copyright 1998 by Matt Riffle All Rights Reserved.			#
# Initial Full Release: 8/4/98 This Release: 8/15/98			#
#									#
# EDITED BY CAL AND CLEANED UP BY SHOCKWAVE FOR UBBCODEHACKING.COM	#
#									#
# Matt Riffle's CgiScripts.Net http://www.cgiscripts.net		#
#########################################################################
#									#
# Usage of this script is subject to compliance with the terms and	#
# conditions set forth below. Your usage of this script is an		#
# acknowledgement that you have read this agreement, and that you	#
# agree to be bound by the terms and conditions below. If you do not	#
# wish to be bound by these terms and conditions, you may not use	#
# this script for any purpose whatsoever.				#
#									#
# You agree to indemnify, defend, and hold harmless Matthew P. Riffle	#
# from any and all liability, penalties, losses, damages, costs,	#
# expenses, attorneys' fees, causes of action or claims caused by or	#
# resulting indirectly from your use of this script which damages	#
# either you, Matthew P. Riffle, or any other party or parties		#
# without limitation or exception. This indemnification and hold	#
# harmless agreement extends to all issues associated with this		#
# script, including but not limited to security, and fitness for a	#
# particular purpose.							#
#									#
# This service is provided on an "as is" basis without warranties of	#
# any kind, either express or implied, including but not limited to	#
# warranties of title, noninfringement, or implied warranties of	#
# merchantability or fitness for a particular purpose. No advice or	#
# information given by Matthew Riffle shall create a warranty.		#
#									#
# Selling the code for this program without prior written consent is	#
# expressly forbidden.							#
#									#
# Obtain permission before redistributing this software over the	#
# Internet or in any other medium. In all cases copyright and header	#
# must remain intact.							#
#									#
#########################################################################

##THANKS TO steveurkel FOR POINTING THIS OUT!!!
require "UltBB.setup";
 
## Set the variables below accordingly ##
# This is the directory in which the script will keep its data files.
# It should be chmod 777 to ensure the server can write to it.
$data_dir = "$CGIPath/Counters";

# If your system can use "flock" to lock data files, set this to 1.
# Otherwise, set it to zero. If you are unsure, try 1 first, and if
# the script is failing try setting it to 0
$flocking = 0;

# This is the format in which the output will be result. Put
# OVERALL where you want the total count, DAILY where you want the
# daily count, and WEEKLY where the weekly count should go. If you
# don't want a certain count, just omit its keyword.
#$format = "OVERALL visits (DAILY today, WEEKLY this week)";
$format = "Accessed OVERALL times (DAILY today, WEEKLY this week)";

# If this is set to 1, the last IP address to access the counter will be
# cached to prevent one person from repeatedly updating the counter. If
# it is set to 0, one person can increment the counter multiple times in
# succession.
$ip_caching = 1;

### Do not edit below this line ###
### Sorry - I must ###

sub InsertCount{
&init; # Insure file exists, create if not
&update; # Update File
}

##########################################################################################################

sub init {
  if ((!$ENV{'SCRIPT_NAME'}) && (!$ENV{'REQUEST_URI'})) { &error(": Web Server Missing Vital ENV Vars! :("); }
  if (!$ENV{'SCRIPT_NAME'}) { $ENV{'SCRIPT_NAME'} = $ENV{'REQUEST_URI'}; }
  $ENV{'SCRIPT_NAME'} =~ s/[^\w]/_/g; 
  if (length($ENV{'SCRIPT_NAME'}) > 240) {
    $name = substr($ENV{'SCRIPT_NAME'},0,240);
  } else {
    $name = $ENV{'SCRIPT_NAME'};
  }
  $name .= ".count";
  my $file = "$data_dir/$name";
  if (!-e $file) {
    open (FILE,">$file") || &error("creating file");
    if ($flocking) { flock(FILE,2) || &error("locking file"); }
    $dstamp = &dstamp;
    $wstamp = &wstamp;
    print FILE "1:1:1:$dstamp:$wstamp:$ENV{'REMOTE_ADDR'}";
    if ($flocking) { flock(FILE,8) || &error(": unlocking file"); }
    close (FILE) || &error(": closing file");
    &report("1","1","1");
  }
}

##########################################################################################################

sub update {
  # Get Data
  my $file = "$data_dir/$name";
  open (FILE,"<$file") || &error("reading file");
  if ($flocking) { flock(FILE,2) || &error("locking file"); }
  my $line = <FILE>;
  if ($flocking) { flock(FILE,8) || &error("unlocking file"); }
  close (FILE);
  # Process Data
  my ($overall,$daily,$weekly,$fdstamp,$fwstamp,$ip) = split(/:/,$line);
  my $dstamp = &dstamp;
  my $wstamp = &wstamp;
  if ($fdstamp < $dstamp) { $daily = 0; $fdstamp = $dstamp; }
  if ($fwstamp < $wstamp) { $weekly = 0; $fwstamp = $wstamp; }
  if ((!$ip_caching) || ($ENV{'REMOTE_ADDR'} ne $ip)) { 
    $overall++; $daily++; $weekly++;
  }
  # Write Data
  open (FILE,">$file") || &error("writing file");
  if ($flocking) { flock(FILE,2) || &error("locking file"); }
  print FILE "$overall:$daily:$weekly:$fdstamp:$fwstamp:$ENV{'REMOTE_ADDR'}";
  if ($flocking) { flock(FILE,8) || &error("unlocking file"); }
  close (FILE) || &error("closing file");
  &report($overall,$daily,$weekly);
}

##########################################################################################################

sub dstamp {
  local($day,$mon,$year,$z1,$z2,$pre);
  $z1 = $z2 = ""; $pre = "19";
  (undef,undef,undef,$day,$mon,$year,undef,undef,undef) = localtime(time);
  $mon++;
  if ($mon < 10) { $z1 = "0"; }
  if ($day < 10) { $z2 = "0"; }
  if ($year < 97) { $pre = "20"; }
  my $stamp = "$pre$year$z1$mon$z2$day";
  return $stamp;
}

##########################################################################################################

sub wstamp {
  local($check,$jump,$day,$mon,$year,$z1,$z2,$pre);
  (undef,undef,undef,undef,undef,undef,$check,undef,undef) = localtime(time);
  $check = 7 - $check;
  $jump = $check * 86400;
  $z1 = $z2 = ""; $pre = "19";
  (undef,undef,undef,$day,$mon,$year,undef,undef,undef) = localtime(time+$jump);
  $mon++;
  if ($mon < 10) { $z1 = "0"; }
  if ($day < 10) { $z2 = "0"; }
  if ($year < 97) { $pre = "20"; }
  my $stamp = "$pre$year$z1$mon$z2$day";
  return $stamp;
}

##########################################################################################################

sub report {
  my ($overall,$daily,$weekly) = @_;
  $format =~ s/OVERALL/$overall/ig;
  $format =~ s/DAILY/$daily/ig;
  $format =~ s/WEEKLY/$weekly/ig;
  print $format;
}

##########################################################################################################

sub error {
  my $error = @_[0];
  print "[Counter Error $error]";
  exit;
}

##########################################################################################################
