#!/usr/bin/perl
#
##################################################################
#         Memberlist (v2.4) for Ultimate Bulletin Board         ##
#   (Heavily modified from v1.8 by leshrac@magictraders.com)    ##
#                  (AIM hack added by isuldor)                  ##
#                      (Y!Mess hack by AJ)                      ##
#                      (Stars hack by cal)                      ##
#                                                               ##
#              Copyright fifteen productions, 1999              ##
#                                                               ##
#      Ultimate Bulletin Board is copyright InfoPop, 2000.      ##
#                                                               ##
# copyright note: feel free to edit this script however you     ##
#  want, however please leave the copyright intact.             ##
#  I will support this script as well as I am able.  If you     ##
#  need help just drop me a line at jeff@lxalumni.com or        ##
#  stop by my site at http://www.lxalumni.com.                  ##
#                        Thanks,                                ##
#                       jeff ross                               ##
#       Also, I would also like to say thank you to             ##
#       Dave Downin for letting me shamelessly steal            ##
#       his paging code.                                        ##
##################################################################
eval {

  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \

require "UltBB.setup";
require "Styles.file";
require "ubb_library.pl";
require "ubb_library2.pl";

};

print ("Content-type: text/html\n\n");

##################################################################
#################### Change These Variables ######################
##################################################################

# $List_Title is what you want the title to say on your Memberlist

$List_Title = "Member List";

# $members_per_page will divide your member list up into multiple
# pages if set to "0" all members will be displayed on one page

$members_per_page = "40";

# $TopPosters sets the number of members to show on your "Top
# Posters" list.

$TopPosters = 25;

# $timeBetween is the number of days that the list will wait before
# recalculating the most likely top posters. You should not change
# this value to anything under 5. If your board has been running for
# a while, or if it does not get much activity, you can set the value
# higher.

$timeBetween = 10;

# $showAll will default the starting page to show all members and
# add an "ALL" link along with the letters. This is option is only
# recommended for smaller boards, such as those with fewer than
# 500 members.
#         "1" turns it on         "0" turns it off

$showAll = 0;

# $UseSearch allows you to add or remove a search field that allows
# users to search for other registered, non-banned users based on
# UserName or e-mail address.
#         "1" turns it on         "0" turns it off

$UseSearch = 1;

# $HideToNonMembers allows you to hide the Memberlist to unregistered
# users. If you enable this, only users who have a UserName cookie
# stored will be able to view the list.
#    "1" allows only members to view    "0" allows anyone to view

$HideToNonMembers = 0;

# $OldStyle allows you to have the the Memberlist use the old style
# of listing the members (no lines in between rows and columns).
#         "1" uses the old style   "0" uses the new style

$OldStyle = 0;

# $ColumnOrder allows you to choose which options you'd like to
# display and the order in which you'd like them to be displayed.
# The ICQ, AIM, Y!Mess, CYMPM, and Who's online options will only
# work if you've installed their respective hacks. Check
# www.ubbhackers.com for more info. Use the following codes to
# order and enable the columns, type in only the exact value
# into @ColumnOrder:
#
# name   = UserName text and link
# email  = E-mail icon and link
# icq    = ICQ indicator and link to pager
# aim    = AIM messenger
# ymess  = Y!Mess messenger
# stars  = Stars ranking images
# home   = Home page icon and link
# pm     = CYMPM icon and link
# online = Who's Online indicator
# find   = User post search icon and link
# loc    = Location text
# occ    = Occupation text
# date   = Date registered text
# ints   = Interests text
# posts  = Number of posts
#
# You MUST use the following format to order the value or the script
# will not function correctly! You can use as many or as few columns
# as you wish. To enable or disable an option, simply add or remove
# it from the list.

@ColumnOrder = ('name', 'email', 'home', 'find', 'loc', 'date', 'ints', 'posts');

# $AIMLoc is the location of the AIM ScreenName in the MEMBERSHIP file

$AIMLoc = 16;

# $YIDLoc is the location of the Y!Mess ID in the MEMBERSHIP file

$YIDLoc = 17;

##################################################################

if ($HideToNonMembers == 1) {
  &get_cookie;
  if ($cookie{'UserName'} eq '') {
    &StandardHTML("Sorry, but only registered users may view this Memberlist. If you are registered on this site, be sure you have cookies enabled in your browser and that you have logged in.");
	exit;
  }
}

&ReadParse;
foreach $temp (@ColumnOrder) {
  if ($temp eq 'name') { $NameEnabled = 'true'; }
  elsif ($temp eq 'email') { $EmailEnabled = 'true'; }
  elsif ($temp eq 'loc') { $LocEnabled = 'true'; }
  elsif ($temp eq 'occ') { $OccEnabled = 'true'; }
  elsif ($temp eq 'ints') { $IntsEnabled = 'true'; }
  elsif ($temp eq 'posts') { $PostsEnabled = 'true'; }
  elsif ($temp eq 'date') { $DateEnabled = 'true'; }
  elsif ($temp eq 'online') { $OnlineEnabled = 'true'; }
}

# define a few variables
$headertext = qq(<font size="$TextSize" face="$FontFace" color="$CategoryStripTextColor"><b>);
$fieldtext = qq(<font size="$TextSize" face="$FontFace">);

$begin1 = '<td align=left>';
$begin2 = '<td align=right>';
$begin3 = '<td align=center>';
$trail  = '</font></td>';

if ($OnlineEnabled eq 'true') {
  &get_cookie;
  &WriteUserSession("<A HREF=\"$CGIURL/memberlist.cgi\">Member List</A>");
  for ($i = 0; $i < @online; $i++) {
    @onlineUser = split(/\|\|/, $online[$i]);
	if ($onlineUser[1] !~ /\.guest$/) { $onlineHash{$onlineUser[1]} = 'online'; }
  }
}

$sortby = $in{'sortby'}; # choose how to sort
if ($sortby == 4) {
  if ($timeBetween < 5) { $timeBetween = 5; }
  $timeBetween = 86400 * $timeBetween;
  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks) = stat "$MembersPath/memlett/top.cgi";
  if ((time - $mtime > $timeBetween) || !(-e "$MembersPath/memlett/top.cgi")) {
    open (MEMS, "<$MembersPath/memberslist.cgi");
      @tempMems = <MEMS>;
    close (MEMS);
	foreach $line (@tempMems) {
	  chomp($line);
	  ($TEMPname, $TEMPProNum) = split(/\|\!\!\|/, $line);
      @TEMPprofile = &OpenProfile("$TEMPProNum.cgi");
      $TEMPPost = $TEMPprofile[7];
      $TEMPPostArray[$qxq++] = qq($TEMPProNum\|\|$TEMPPost);
	} #end foreach

	@sortPosts = sort {
      ($ProNumA, $PostA) = split(/\|\|/, $a);
      ($ProNumB, $PostB) = split(/\|\|/, $b);
      $PostB <=> $PostA; } @TEMPPostArray;
    if ($#sortPosts > $TopPosters + 20) { $#sortPosts = $TopPosters + 20; }

    foreach $line (@sortPosts) { $line = "$line\n"; }
    &Lock ("lock.file");
    open (LIST, ">$MembersPath/memlett/top.cgi");
      print LIST @sortPosts;
    close (LIST);
    &Unlock ("lock.file");
    chmod (0666, "$MembersPath/memlett/top.cgi");
  } #end time if
} #end sortby if

# For multipage hack
$page = $in{'page'};
if (!$page) { $page = 1; }
$start_at = (($page * $members_per_page) - $members_per_page) + 1;
$letter = $in{'letter'}; # choose which letter to sort by
if (($showAll == 1) && ($sortby != 4) && ($s ne 'email')) { if (!$letter) { $letter = "ALL"; } }
 else { if (!$letter) { $letter = "A"; } }
$s = $in{'s'}; # choose what to search by
$svalue = $in{'svalue'};
if ($svalue) { $goodSvalue = quotemeta($svalue); }
$ColSpan = 3 - $UseSearch;
$setot = 0;

# Add/Remove Registration feature
if ($SuspendRegister eq "false") {
  $RegLinkHere = qq(<A HREF="$CGIURL/Ultimate.cgi?action=agree"><ACRONYM TITLE="Registration is free!">register</ACRONYM></A> |);}
else {$RegLinkHere = "";}

# Add/Remove Search icon feature
if ($AllowSearch eq "TRUE") {
  $SearchOption = qq(| <A HREF="$CGIURL/search.cgi?action=intro"><ACRONYM TITLE="Perform a search by keyword, date, or name.">search</ACRONYM></A> );}
else {$SearchOption  = "";}

# find members
if ((($s eq 'name') && $svalue) || ($letter eq 'ALL')) { open (INDEX, "<$MembersPath/memberslist.cgi"); }
 elsif (($s eq 'email') && $svalue) { open (INDEX, "<$MembersPath/emailfile.cgi"); }
 elsif (($s eq 'location') && $svalue) { open (INDEX, "<$MembersPath/memlett/location.cgi"); }
 elsif (($s eq 'interests') && $svalue) { open (INDEX, "<$MembersPath/memlett/interests.cgi"); }
 elsif (($s eq 'occupation') && $svalue) { open (INDEX, "<$MembersPath/memlett/occupation.cgi"); }
 elsif ($sortby == 4) { open (INDEX, "<$MembersPath/memlett/top.cgi"); }
 else { open (INDEX, "<$MembersPath/memlett/$letter.cgi"); }
MEMBERS: while ($line = <INDEX> ) {
chomp($line);
if ($s eq 'email') { ($name, $ProfileNumber) = split(/\|\|/, $line); }
 elsif (($s eq 'location') || ($s eq 'interests')) { ($ProfileNumber, $name) = split(/\|\!\^\!\|/, $line); }
 elsif (($sortby == 4) && ($letter ne 'ALL')) { ($ProfileNumber, $Posts) = split(/\|\|/, $line); }
 else { ($name, $ProfileNumber) = split(/\|\!\!\|/, $line); }
if (($name =~ /$goodSvalue/i) || (!$s)) { # do search
@thisprofile = &OpenProfile("$ProfileNumber.cgi"); # grab info from profiles
if (($thisprofile[0] ne '') && ($thisprofile[4] ne '&') && ($thisprofile[4] ne '&COPPA')) { #exclude banned members
$setot++;
$ThisHome = $thisprofile[3];
$name = $thisprofile[0];
$pro = $name;
$pro = &HTMLIFY($pro);
$pro =~ s/ /+/g;
$Occ = $thisprofile[5];
$Loc = $thisprofile[6];
$Post = $thisprofile[7];
$Int = $thisprofile[9];
$EmailView = $thisprofile[11];
$date = $thisprofile[10];
$date =~ s/-9/-199/g;
my ($mon, $day, $year) = split(/-/, $date);
$hDate = "<!- $year/$mon/$day ->";
$year =~ s/19//g;
$year =~ s/20//g;
$Date = "$mon/$day/$year";
$ThisStatus = $thisprofile[8];
if ($ThisStatus eq "Administrator") {
  $Stars = qq(<img src="$NonCGIURL/star.gif"><img src="$NonCGIURL/star.gif"><img src="$NonCGIURL/star.gif"><img src="$NonCGIURL/star.gif"><img src="$NonCGIURL/star.gif">);
} elsif ($ThisStatus eq "Moderator") {
  $Stars = qq(<img src="$NonCGIURL/star.gif"><img src="$NonCGIURL/star.gif"><img src="$NonCGIURL/star.gif"><img src="$NonCGIURL/star.gif">);
} else {
  $Stars = qq(<img src="$NonCGIURL/stars.gif">);
  if ($thisprofile[7] > 4) { $Stars = qq(<img src="$NonCGIURL/star.gif">); }
  if ($thisprofile[7] > 100) { $Stars .= qq(<img src="$NonCGIURL/star.gif">); }
  if ($thisprofile[7] > 500) { $Stars .= qq(<img src="$NonCGIURL/star.gif">); }
}

# Get rid of empty fields
if (!$Int) { if ($sortby == 5) { next MEMBERS; } else { $Int = "&nbsp;"; } }
if (!$Loc) { if ($sortby == 3) { next MEMBERS; } else { $Loc = "&nbsp;"; } }
if (!$Occ) { if ($sortby == 6) { next MEMBERS; } else { $Occ = "&nbsp;"; } }
if ($Date eq "//") { if ($sortby == 2) { next MEMBERS; } else { $Date = "&nbsp;"; } }

# Link name to profile
$Name = "<a href=$CGIURL/ubbmisc.cgi?action=getbio&UserName=$pro>$name</a>";

# PM icon and link
if (-e "$CGIPath/private/$name.pref") {
  open (PREFS,"$CGIPath/private/$name.pref");
  LINE: while(<PREFS> ){
    next LINE if (/^#/); # Skip comment lines.
    next LINE if (/^\s*$/); # Skip blank lines.
    @data=split (/\|/);
    $prefs{$data[4]} = $data[5]; 
  }
  close (PREFS);
}

if (($prefs{'status'} ne "off") && ($thisprofile[7] > 0)) {
  $PM = qq(&nbsp;&nbsp;<a href="$CGIURL/privatesend.cgi?sendto=$pro" target="_blank"><img src="$NonCGIURL/pmimages/pm.gif" border=0 height=16 alt="Send a private message to $name"></a>&nbsp;&nbsp;);
} else {
  $PM = "&nbsp;";
}

# Home page icon and link
if (substr($ThisHome, 0, 3) eq "www") {
 $ThisHome = "http://" . $thisprofile[3];
 $thisprofile[3] = $ThisHome; }
if (($ThisHome ne "") && ($ThisHome ne "http://") && (substr($ThisHome, 0, 7) eq "http://")) {
  $ThisHome = qq(&nbsp;&nbsp;<a href="$thisprofile[3]" Target=_blank><img src="$NonCGIURL/Home.gif" alt="Visit $name\'s Homepage" border=0></a>&nbsp;&nbsp;);
} else {
  $ThisHome = "&nbsp;";
}

# Search for posts icon and link
if ($thisprofile[7] > 0) {
 $FindUserPosts = qq(&nbsp;&nbsp;<a href="$CGIURL/search.cgi?action=simplesearch&ForumChoice=ALL&ExactName=yes&SearchUser=$pro" target=_blank><img src="$NonCGIURL/find.gif" border=0 width=40 height=16 alt="Search for posts by $name"></a>&nbsp;&nbsp;);
} else {
 $FindUserPosts = "&nbsp;";
}

# E-mail icon and link
if (($EmailBlock eq "ON") || ($EmailView eq "no")) {
 $EmailString = "&nbsp;";
} else {
 $EmailString = qq(&nbsp;&nbsp;<A HREF="mailto:$thisprofile[2]"><IMG SRC="$NonCGIURL/email.gif" BORDER=0 ALT="Send e-mail to $name"></A>&nbsp;&nbsp;);
} 	

# ICQ icon and link
if ($thisprofile[13] > 1000) {
 $ICQ = qq(&nbsp;&nbsp;<a href="javascript:icqwindow('$CGIURL/ubbmisc.cgi?action=icqmessage&UIN=$thisprofile[13]')"><img src=http://online.mirabilis.com/scripts/online.dll?icq=$thisprofile[13]&img=5 alt="ICQ: $thisprofile[13]" border=0></a>&nbsp;&nbsp;);
} else {
 $ICQ = "&nbsp;";
}

# AIM icon and link
if ($thisprofile[$AIMLoc] ne '') {
 $AIM = qq(&nbsp;&nbsp;<a href="javascript:aimwindow('$CGIURL/ubbmisc.cgi?action=aimmessage&AIM=$thisprofile[$AIMLoc]')"><img src="$NonCGIURL/aim_icon.gif" alt="Send a message to $thisprofile[$AIMLoc]" border=0></a>&nbsp;&nbsp;);
} else {
 $AIM = "&nbsp;";
}

# Y!Mess icon and link
if ($thisprofile[$YIDLoc] ne '') {
 $YID = qq(&nbsp;&nbsp;<a href="http://edit.yahoo.com/config/send_webmesg?.target=$thisprofile[$YIDLoc]&.src=pg" target="_blank"><img src="http://opi.yahoo.com/online?u=$thisprofile[$YIDLoc]&m=g&t=0" alt="Send a message to $thisprofile[$YIDLoc]" border=0 align=abscenter></a>&nbsp;&nbsp;);
} else {
 $YID = "&nbsp;";
}

# Who's Online icon
if ($onlineHash{$name} eq 'online') {
 $OnlineIcon = qq(&nbsp;&nbsp;<img src="$NonCGIURL/online.gif">&nbsp;&nbsp;);
} else {
 $OnlineIcon = "&nbsp;";
}

unless (($s eq 'email') && ($EmailView eq "no")) { # exclude members with email blocked if search by email

# create lists
$totHold = $tot++;
$namelist[$totHold] = '';
$sorterValue = '';
for ($e = 0; $e < @ColumnOrder; $e++) {
  $namelistHold = '';
  $ColumnElement = $ColumnOrder[$e];
  if (($e == $#ColumnOrder) && ($e != 0)) { $begin = $begin2; }
   else { $begin = $begin1; }
  if ($ColumnElement eq 'name') { $namelistHold .= "$fieldtext<b>$Name</b>$trail"; }
  elsif ($ColumnElement eq 'email') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$EmailString$trail";
  }
  elsif ($ColumnElement eq 'icq') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$ICQ$trail";
  }
  elsif ($ColumnElement eq 'aim') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$AIM$trail";
  }
  elsif ($ColumnElement eq 'ymess') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$YID$trail";
  }
  elsif ($ColumnElement eq 'online') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$OnlineIcon$trail";
  }
  elsif ($ColumnElement eq 'home') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$ThisHome$trail";
  }
  elsif ($ColumnElement eq 'pm') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$PM$trail";
  }
  elsif ($ColumnElement eq 'find') {
    $begin = $begin3;
    $namelistHold .= "$fieldtext$FindUserPosts$trail";
  }
  elsif ($ColumnElement eq 'loc') {
	if ($sortby == 3) {
	  $namelistHold .= "$fieldtext<b>$Loc</b>$trail";
	  $sorterValue = "<!- $Loc ->";
	} else { $namelistHold .= "$fieldtext$Loc$trail"; }
  }
  elsif ($ColumnElement eq 'date') {
    $begin = $begin3;
	if ($sortby == 2) {
	  $namelistHold .= "$fieldtext<b>$Date</b>$trail";
	  $sorterValue = $hDate;
	} else { $namelistHold .= "$fieldtext$Date$trail"; }
  }
  elsif ($ColumnElement eq 'ints') {
	if ($sortby == 5) {
	  $namelistHold .= "$fieldtext<b>$Int</b>$trail";
	  $sorterValue = "<!- $Int ->";
	} else { $namelistHold .= "$fieldtext$Int$trail"; }
  }
  elsif ($ColumnElement eq 'posts') {
	if ($sortby == 4) {
	  $namelistHold .= "$fieldtext<b>$Post</b>$trail";
	  $sorterValue = "<!- $Post ->";
	} else { $namelistHold .= "$fieldtext$Post$trail"; }
  }
  elsif ($ColumnElement eq 'occ') {
	if ($sortby == 6) {
	  $namelistHold .= "$fieldtext<b>$Occ</b>$trail";
	  $sorterValue = "<!- $Occ ->";
	} else { $namelistHold .= "$fieldtext$Occ$trail"; }
  }
  elsif ($ColumnElement eq 'stars') {
    $namelistHold .= "$fieldtext$Stars$trail";
  }
  $namelist[$totHold] .= "$begin$namelistHold";
}
$namelist[$totHold] = qq($sorterValue<!- $name ->$namelist[$totHold]</tr>\n);

} #end exclude email block
} #end banned check
} #end do search
}

close (INDEX);

&page;
if (!$svalue) { &letter; }
 else { $letter = "&nbsp;"; }

if (!$svalue) {
  &GetMemberListArray;
  $TotalMembers = @members;
} else {
  $TotalMembers = $setot;
}

# print header
print<<HEAD1;
<html>
<head>
$HeaderInsert
<title>$List_Title</title>
<script language="javascript">
function icqwindow(windowname) \{ var MainWindow = window.open (windowname, "_blank","toolbar=no,location=no,menubar=no,scrollbars=no,width=450,height=300,resizeable=yes,status=no");\}
function aimwindow(windowname) \{ var MainWindow = window.open (windowname, "_blank","toolbar=no,location=no,menubar=no,scrollbars=no,width=175,height=275,resizeable=yes,status=no");\}
</script>
</head>
<BODY bgcolor="$BGColor" background="$NonCGIURL/$PageBackground" text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
<FONT FACE="$FontFace" SIZE="$TextSize">
$Header
<center>
<table border=0 width=$TableWidth><tr><TD>
<CENTER>
<A HREF="Ultimate.cgi"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A>
</CENTER>
</td>
<td><CENTER>
<B><FONT SIZE="3" FACE="$FontFace" COLOR="$BBTitleFontColor">$BBName</FONT></B>
<br><FONT SIZE="1" FACE="$FontFace">
<A HREF="$CGIURL/ubbmisc.cgi?action=editbio"><ACRONYM TITLE="Click here to edit your profile.">profile</ACRONYM></A> | $RegLinkHere <A HREF="$CGIURL/ubbmisc.cgi?action=setprefs"><ACRONYM TITLE="Set your preferences.">preferences</ACRONYM></A> | <A HREF="$NonCGIURL/faq.html" target=_blank><ACRONYM TITLE="Frequently Asked Questions">faq</ACRONYM></A> $SearchOption
</font></font></table>
</font>
<center><br>
<table border=0 width=$TableWidth cellspacing=0 cellpadding=0>
<tr>
HEAD1
if ($UseSearch == 1) {
print<<HEADs;
<td><font face=$FontFace size=$TextSize><form method=POST action="$CGIURL/memberlist.cgi"><input type=submit value="Search by"></font>
<select name="s">
HEADs
if ($NameEnabled  eq 'true') { print qq(<option value="name">UserName</option>); }
if ($EmailEnabled eq 'true') { print qq(<option value="email">E-Mail</option>); }
if ($IntsEnabled  eq 'true') { print qq(<option value="interests">Interests</option>); }
if ($LocEnabled   eq 'true') { print qq(<option value="location">Location</option>); }
if ($OccEnabled   eq 'true') { print qq(<option value="occupation">Occupation</option>); }
print '</select></td>';
}
print "<td colspan=$ColSpan align=right>$pages</td></tr><tr>";
if ($UseSearch == 1) { print qq(<td><INPUT TYPE="TEXT" NAME="svalue" SIZE=25></td></form>); }
if ($sortby == 4) {
 if ($letter ne 'ALL') { $TotalMembers = $TopPosters; }
 if ($showAll == 1) { $letters = qq(<FONT FACE="$FontFace" SIZE="$TextSize"><A HREF="$CGIURL/memberlist.cgi?page=1&sortby=$sortby&letter=ALL">ALL</A></font>); }
  else { $letters = '&nbsp'; }
}
print<<HEAD2;
<td colspan=$ColSpan align=right>$letters</td></tr>
<tr bgcolor=$TableColorStrip><td align=center><font face=verdana size=+3 color=$TableStripTextColor><strong>$List_Title</strong></td><td align=center><font size=$TextSize face=$FontFace color=$TableStripTextColor><strong>$TotalMembers</strong>
HEAD2
if (!$svalue) { print 'Members'; }
 else { print 'Results'; }
print<<HEAD3;
</td><td><center><form method=POST action="$CGIURL/memberlist.cgi">
<input type=submit value="Sort by">
<select name="sortby">
HEAD3
if ($NameEnabled  eq 'true') { print qq(<option value="1">Name</option>); }
if ($PostsEnabled eq 'true') { print qq(<option value="4">Top $TopPosters Posters</option>); }
if ($DateEnabled  eq 'true') { print qq(<option value="2">Date Reg.</option>); }
if ($IntsEnabled  eq 'true') { print qq(<option value="5">Interests</option>); }
if ($LocEnabled   eq 'true') { print qq(<option value="3">Location</option>); }
if ($OccEnabled   eq 'true') { print qq(<option value="6">Occupation</option>); }
print q(</select></td></tr><tr><td colspan=3><center>);
if ($OldStyle == 1) {
  print q(<table border=0 width=100% cellspacing=0 cellpadding=2>);
} else {
print qq(<table border=0 cellpadding=0 cellspacing=0 width="100%"><TR><td bgcolor="$TableBorderColor"><table cellpadding=3 cellspacing=1 border=0 width="100%">);
}
print<<HEAD4;
<tr bgcolor=$CategoryStripColor>
HEAD4
$HeaderStrip = '';
for ($e = 0; $e < @ColumnOrder; $e++) {
  $ColumnElement = $ColumnOrder[$e];
  if (($e == $#ColumnOrder) && ($e != 0)) { $begin = $begin2; }
   else { $begin = $begin1; }
  if ($ColumnElement eq 'name')      { $HeaderStrip .= "$begin$headertext Name</b>$trail"; }
  elsif ($ColumnElement eq 'email')  { $HeaderStrip .= "$begin3$headertext E-Mail</b>$trail"; }
  elsif ($ColumnElement eq 'icq')    { $HeaderStrip .= "$begin3$headertext &nbsp;&nbsp;ICQ&nbsp;&nbsp;</b>$trail"; }
  elsif ($ColumnElement eq 'aim')    { $HeaderStrip .= "$begin3$headertext &nbsp;&nbsp;AIM&nbsp;&nbsp;</b>$trail"; }
  elsif ($ColumnElement eq 'ymess')  { $HeaderStrip .= "$begin3$headertext &nbsp;&nbsp;Y!&nbsp;&nbsp;</b>$trail"; }
  elsif ($ColumnElement eq 'online') { $HeaderStrip .= "$begin3$headertext Online?</b>$trail"; }
  elsif ($ColumnElement eq 'home')   { $HeaderStrip .= "$begin3$headertext Home</b>$trail"; }
  elsif ($ColumnElement eq 'pm')     { $HeaderStrip .= "$begin3$headertext &nbsp;&nbsp;PM&nbsp;&nbsp;</b>$trail"; }
  elsif ($ColumnElement eq 'find')   { $HeaderStrip .= "$begin3$headertext Find</b>$trail"; }
  elsif ($ColumnElement eq 'loc')    { $HeaderStrip .= "$begin$headertext Location</b>$trail"; }
  elsif ($ColumnElement eq 'date')   { $HeaderStrip .= "$begin3$headertext Date Reg.</b>$trail"; }
  elsif ($ColumnElement eq 'ints')   { $HeaderStrip .= "$begin$headertext Interests</b>$trail"; }
  elsif ($ColumnElement eq 'occ')    { $HeaderStrip .= "$begin$headertext Occupations</b>$trail"; }
  elsif ($ColumnElement eq 'posts')  { $HeaderStrip .= "$begin$headertext Posts</b>$trail"; }
  elsif ($ColumnElement eq 'stars')  { $HeaderStrip .= "$begin$headertext Stars</b>$trail"; }
}
print "$HeaderStrip</tr>\n";

# choose list to display
if ($sortby == 4) { &posts; }
 else { &name; }

# print footer
print '</table>';
if ($OldStyle == 0) { print '</td></tr></table>'; }
print<<FOOT;
</td></tr>
<tr><td colspan=3 align=right>$letters</td></tr>
<tr><td colspan=3 align=right>$pages</td></tr>
<tr><td colspan=3><font color=$CopyrightTextColor size=1><center>This memberlist (v2.4) was based on v1.8 by, fifteen productions.</center></td></tr></table>
</table>
<p>
$Footer
<br></form></body></html>
FOOT

# organize lists and display
sub name {
if ($sortby == 2) { @nlist = sort {lc($b) cmp lc($a)} @namelist; }
 else { @nlist = sort {lc($a) cmp lc($b)} @namelist; }
if ((@nlist - $start_at) < $members_per_page) {
  $members_per_page = @nlist - $start_at;
}
for ($i = $start_at; $i <= ($start_at + $members_per_page); $i++) {
print qq~<tr bgcolor=~;
if ($i % 2) {print "$AltColumnColor1";} else {print "$AltColumnColor2";}
print qq~>$nlist[$i - 1]~;}
} #end name sub

sub posts {
@plist = sort {
  $A = $a; $B = $b;
  $A =~ s/<!-(.+?)->.*/$1/g;
  $B =~ s/<!-(.+?)->.*/$1/g;
  lc($B) <=> lc($A);
} @namelist;
if ($letter ne 'ALL') { $#plist = $TopPosters - 1; }
for ($i = $start_at; $i < ($start_at + $TopPosters); $i++) {
print qq~<tr bgcolor=~;
if ($i % 2) {print "$AltColumnColor1";} else {print "$AltColumnColor2";}
print qq~>$plist[$i - 1]~;}
} #end posts sub

sub page {
 if (($sortby == 4) && ($letter ne 'ALL')) { $tot = $TopPosters; }
 if (!$members_per_page) { $members_per_page = $tot + 1; }
 $total_pages = ($tot + 1)/$members_per_page;
 if ($total_pages > int(($tot + 1)/$members_per_page)) { $total_pages++; }
 $pages = qq(<FONT FACE="$FontFace" SIZE="$TextSize">Page: );
 for ($i = 1; $i <= $total_pages; $i++) {
   if ($page eq $i) {
     $pages .= "$i ";
   } else {
     $pages .= qq(<A HREF="$CGIURL/memberlist.cgi?page=$i&sortby=$sortby&letter=$letter&s=$s&svalue=$svalue">$i</A> );
   }
 }
 $pages .= qq(</FONT>);

} #end page sub

sub letter {
if ($showAll == 1) { $lStart = 0; }
 else { $lStart = 1; }
@alphabet = ("ALL", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", '@');
$letters = qq(<FONT FACE="$FontFace" SIZE="$TextSize">Letter: );
for ($l = $lStart; $l <= 27; $l++) {
  if ($letter eq $alphabet[$l]) {
    $letters .= "$alphabet[$l] ";
  } else {
     $letters .= qq(<A HREF="$CGIURL/memberlist.cgi?page=1&sortby=$sortby&letter=$alphabet[$l]">$alphabet[$l]</A> );
  }
}
$letters .= qq(</FONT>);
} #end letter sub
